import React from "react";
import { useForm } from "react-hook-form";



export default function PromotionNewFormComponent () {
    const { register, watch, handleSubmit, formState: { errors } } = useForm();
    
    const onSubmit = (data) => {
        console.log(data)
        alert(JSON.stringify(data));
        fetch("http://localhost:8081/api/promos", {
            method: "POST",
            headers: {
                "Content-Type": "application/json",
            },
            body: JSON.stringify(data),
            })
            .then(res => res.json())
            .catch(err => console.log(err.data))
    };

    console.log(errors);
    console.log(watch);
    return (
        <div>
            <div>
                <h1>Create New Promotion</h1>
            </div>
            <form onSubmit={handleSubmit(onSubmit)}>
                <label>Promotion Id</label>
                <input 
                    {...register("promotionId", {
                        required: "promotion id is required",
                        maxLength: { value: 10, message: "You exceeded the maximum value" }
                    })}
                    id="promotionId"
                />
                {errors.promotionId === 'required'  && <p>{errors.promotionId.message}</p>}
                        <br></br>
                <label>Promotion Sku</label>
                <input
                    {...register("productSku", {
                        required: true,
                    })}
                    id="productSku"
                />
                {errors?.promotionSku?.type === "required" && <p>This field is required</p>}
                <br></br>

                <label>Discount Percentage</label>
                <input
                    {...register("discountPercentage", {
                        valueAsNumber: true,
                        required: true,
                    })}
                    id="discountPercentage"
                />
                <br></br>
                {errors?.discountPercentage?.type === "required" && <p>This field is required</p>}
                
                <label>minimumQuanitity</label>
                <input
                    {...register("minimumQuantity", {
                        valueAsNumber: true,
                        required: "this field is required",
                    })}
                    id="minimumQuantity"
                />
                {errors.minimumQuantity && <p>{errors.minimumQuantity}</p>}

                <input type="submit" />
            </form>
        </div>
    );
}

